/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/**
 * @file rose_value.tpp
 * @brief The implementation of class @a rose_value. 
 * @author Kiminori MATSUZAKI
 */

#ifdef __ROSE_VALUE_H__
#ifndef __ROSE_VALUE_TPP__
#define __ROSE_VALUE_TPP__

////////////////////////////////////////////////////////////////////////
// Constructor and Destructor
template< typename A >
rose_value< A >::rose_value( const A& value_,
			     valuetype_t valuetype_ )
  : valuetype( valuetype_ ),
    value( value_ )
{
}

template< typename A >
rose_value< A >::rose_value( )
{
}

template< typename A >
rose_value< A >::~rose_value( )
{
}

template< typename A >
std::ostream&
operator<<( std::ostream& os,
	    const rose_value< A >& a )
{
  if ( a.valuetype == rose_value< A >::ORGLEAF ||
       a.valuetype == rose_value< A >::ORGNODE ) {
    os << a.valuetype << " " << a.value;
  } else {
    os << a.valuetype;
  }
  return os;
}

template< typename A >
std::istream&
operator>>( std::istream& is,
	    rose_value< A >& a )
{
  is >> (int)a.valuetype;
  if ( a.valuetype == rose_value< A >::ORGLEAF ||
       a.valuetype == rose_value< A >::ORGNODE ) {
    is >> a.value;
  }
  return is;
}

#endif /* __ROSE_VALUE_TPP__ */
#endif /* __ROSE_VALUE_H__ */
