/***
 * Copyright (c) 2005, SkeTo Project
 * All rights reserved.
 */
/**
 * @file test_rose_value.cpp
 * @brief Test code for @a rose_value.h and @a rose_value.tpp. 
 * @author Kiminori MATSUZAKI
 */

#include <assert.h>
#include <iostream>
#include <sstream>
#include <string>

#include <dist_tree.h>
#include <rose_value.h>

void test_rose_value_constructor_destructor_and_stream( )
{
  rose_value< double > *rv1
    = new rose_value< double >( 10.5, rose_value< double >::ORGNODE );

  rose_value< double > *rv2
    = new rose_value< double >( );

  std::string buf_in
    = std::string( "1 10.5" ); // type = ORGNODE, value = 10.5
  string buf_out;
  std::ostringstream os;
  
  std::istringstream is( buf_in );
  is >> *rv2;

  assert( rv1->valuetype == rv2->valuetype &&
	  rv1->value     == rv2->value );

  os << *rv2;
  buf_out = os.str();
  
  assert( buf_out == buf_in );

  return;
}

int SketoMain( int, char** )
{
  if ( skeleton::rank == 0 ) {
    cout << "Testing " __FILE__ << endl;

    test_rose_value_constructor_destructor_and_stream( );

    cout << "   ---> OK " __FILE__ << endl;
  }    
  return 0;
}
